<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: src/core/CL/cl_kernels/non_linear_filter_helpers.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('non__linear__filter__helpers_8h.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">non_linear_filter_helpers.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a href="non__linear__filter__helpers_8h_source.xhtml">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ac226bc1ed04fd7d4865263484ed22a47"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(a,  b)</td></tr>
<tr class="memdesc:ac226bc1ed04fd7d4865263484ed22a47"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sorts element-wise two vectors.  <a href="#ac226bc1ed04fd7d4865263484ed22a47">More...</a><br /></td></tr>
<tr class="separator:ac226bc1ed04fd7d4865263484ed22a47"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a7b5c174de888c3cfa7c08c16682fd770"><td class="memItemLeft" align="right" valign="top">uchar8&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#a7b5c174de888c3cfa7c08c16682fd770">sort5</a> (uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4)</td></tr>
<tr class="memdesc:a7b5c174de888c3cfa7c08c16682fd770"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sorting network to sort 5 vectors of 8 elements and return their median.  <a href="#a7b5c174de888c3cfa7c08c16682fd770">More...</a><br /></td></tr>
<tr class="separator:a7b5c174de888c3cfa7c08c16682fd770"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0960df49e39a9499677066c32600c17f"><td class="memItemLeft" align="right" valign="top">uchar8&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#a0960df49e39a9499677066c32600c17f">sort9</a> (uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4, uchar8 p5, uchar8 p6, uchar8 p7, uchar8 p8)</td></tr>
<tr class="memdesc:a0960df49e39a9499677066c32600c17f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sorting network to sort 9 vectors of 8 elements and return their median.  <a href="#a0960df49e39a9499677066c32600c17f">More...</a><br /></td></tr>
<tr class="separator:a0960df49e39a9499677066c32600c17f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3e09114bb887de4e20122eed42671a1"><td class="memItemLeft" align="right" valign="top">uchar8&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#ae3e09114bb887de4e20122eed42671a1">row_reduce_min_3</a> (uchar16 val)</td></tr>
<tr class="memdesc:ae3e09114bb887de4e20122eed42671a1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the minimum of a sliding window of size 3.  <a href="#ae3e09114bb887de4e20122eed42671a1">More...</a><br /></td></tr>
<tr class="separator:ae3e09114bb887de4e20122eed42671a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3138dafa8474a59f73dd837073f18ed7"><td class="memItemLeft" align="right" valign="top">uchar8&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#a3138dafa8474a59f73dd837073f18ed7">row_reduce_max_3</a> (uchar16 val)</td></tr>
<tr class="memdesc:a3138dafa8474a59f73dd837073f18ed7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the maximum of a sliding window of size 3.  <a href="#a3138dafa8474a59f73dd837073f18ed7">More...</a><br /></td></tr>
<tr class="separator:a3138dafa8474a59f73dd837073f18ed7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9d1bdcaf911a5b861c2082181e6a716"><td class="memItemLeft" align="right" valign="top">uchar8&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a> (uchar16 val)</td></tr>
<tr class="memdesc:aa9d1bdcaf911a5b861c2082181e6a716"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the minimum of a sliding window of size 5.  <a href="#aa9d1bdcaf911a5b861c2082181e6a716">More...</a><br /></td></tr>
<tr class="separator:aa9d1bdcaf911a5b861c2082181e6a716"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a310f21b7cf0409431ddf246c4a98e52e"><td class="memItemLeft" align="right" valign="top">uchar8&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a> (uchar16 val)</td></tr>
<tr class="memdesc:a310f21b7cf0409431ddf246c4a98e52e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the maximum of a sliding window of size 5.  <a href="#a310f21b7cf0409431ddf246c4a98e52e">More...</a><br /></td></tr>
<tr class="separator:a310f21b7cf0409431ddf246c4a98e52e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a class="anchor" id="ac226bc1ed04fd7d4865263484ed22a47"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SORT</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">b&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">{                               \</div><div class="line">        uchar8 min_val = min(a, b); \</div><div class="line">        uchar8 max_val = max(a, b); \</div><div class="line">        a              = min_val;   \</div><div class="line">        b              = max_val;   \</div><div class="line">    }</div></div><!-- fragment -->
<p>Sorts element-wise two vectors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">a</td><td>First vector </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">b</td><td>Second vector </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00030">30</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00178">median_box5x5()</a>, <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00039">median_disk5x5()</a>, <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00050">sort5()</a>, and <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00078">sort9()</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="a3138dafa8474a59f73dd837073f18ed7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uchar8 row_reduce_max_3 </td>
          <td>(</td>
          <td class="paramtype">uchar16&#160;</td>
          <td class="paramname"><em>val</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculate the maximum of a sliding window of size 3. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">val</td><td>Values to calculate the maximum values</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Maximum values of 8 elements on a sliding window of size 3. </dd></dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00120">120</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00044">non_linear_filter_box3x3()</a>, <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00099">non_linear_filter_cross3x3()</a>, <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00150">non_linear_filter_disk3x3()</a>, and <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00444">non_linear_filter_disk5x5()</a>.</p>
<div class="fragment"><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;{</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">return</span> max(val.s01234567, max(val.s12345678, val.s23456789));</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a310f21b7cf0409431ddf246c4a98e52e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uchar8 row_reduce_max_5 </td>
          <td>(</td>
          <td class="paramtype">uchar16&#160;</td>
          <td class="paramname"><em>val</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculate the maximum of a sliding window of size 5. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">val</td><td>Values to calculate the maximum values</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Maximum values of 8 elements on a sliding window of size 5. </dd></dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00142">142</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00339">non_linear_filter_box5x5()</a>, <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00387">non_linear_filter_cross5x5()</a>, and <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00444">non_linear_filter_disk5x5()</a>.</p>
<div class="fragment"><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;{</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">return</span> max(val.s01234567, max(max(val.s12345678, val.s23456789), max(val.s3456789A, val.s456789AB)));</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="ae3e09114bb887de4e20122eed42671a1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uchar8 row_reduce_min_3 </td>
          <td>(</td>
          <td class="paramtype">uchar16&#160;</td>
          <td class="paramname"><em>val</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculate the minimum of a sliding window of size 3. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">val</td><td>Values to calculate the minimum values</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Minimum values of 8 elements on a sliding window of size 3. </dd></dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00109">109</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00044">non_linear_filter_box3x3()</a>, <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00099">non_linear_filter_cross3x3()</a>, <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00150">non_linear_filter_disk3x3()</a>, and <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00444">non_linear_filter_disk5x5()</a>.</p>
<div class="fragment"><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;{</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordflow">return</span> min(val.s01234567, min(val.s12345678, val.s23456789));</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="aa9d1bdcaf911a5b861c2082181e6a716"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uchar8 row_reduce_min_5 </td>
          <td>(</td>
          <td class="paramtype">uchar16&#160;</td>
          <td class="paramname"><em>val</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculate the minimum of a sliding window of size 5. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">val</td><td>Values to calculate the minimum values</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Minimum values of 8 elements on a sliding window of size 5. </dd></dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00131">131</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00339">non_linear_filter_box5x5()</a>, <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00387">non_linear_filter_cross5x5()</a>, and <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00444">non_linear_filter_disk5x5()</a>.</p>
<div class="fragment"><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;{</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordflow">return</span> min(val.s01234567, min(min(val.s12345678, val.s23456789), min(val.s3456789A, val.s456789AB)));</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a7b5c174de888c3cfa7c08c16682fd770"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uchar8 sort5 </td>
          <td>(</td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p3</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p4</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sorting network to sort 5 vectors of 8 elements and return their median. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">p0</td><td>First element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p1</td><td>Second element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p2</td><td>Third element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p3</td><td>Fourth element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p4</td><td>Fifth element vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Median values for 8 elements. </dd></dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00050">50</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>References <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00030">SORT</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00099">non_linear_filter_cross3x3()</a>.</p>
<div class="fragment"><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p1);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p3);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p2);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p3);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p4);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p4);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p4);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordflow">return</span> p2;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;}</div><div class="ttc" id="non__linear__filter__helpers_8h_xhtml_ac226bc1ed04fd7d4865263484ed22a47"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a></div><div class="ttdeci">#define SORT(a, b)</div><div class="ttdoc">Sorts element-wise two vectors. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00030">non_linear_filter_helpers.h:30</a></div></div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a0960df49e39a9499677066c32600c17f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uchar8 sort9 </td>
          <td>(</td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p3</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p4</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p5</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p6</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p7</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uchar8&#160;</td>
          <td class="paramname"><em>p8</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sorting network to sort 9 vectors of 8 elements and return their median. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">p0</td><td>First element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p1</td><td>Second element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p2</td><td>Third element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p3</td><td>Fourth element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p4</td><td>Fifth element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p5</td><td>Sixth element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p6</td><td>Seventh element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p7</td><td>Eigth element vector </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">p8</td><td>Ninth element vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Median values for 8 elements. </dd></dl>

<p>Definition at line <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00078">78</a> of file <a class="el" href="non__linear__filter__helpers_8h_source.xhtml">non_linear_filter_helpers.h</a>.</p>

<p>References <a class="el" href="non__linear__filter__helpers_8h_source.xhtml#l00030">SORT</a>.</p>

<p>Referenced by <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00044">non_linear_filter_box3x3()</a>, <a class="el" href="non__linear__filter5x5_8cl_source.xhtml#l00387">non_linear_filter_cross5x5()</a>, and <a class="el" href="non__linear__filter3x3_8cl_source.xhtml#l00150">non_linear_filter_disk3x3()</a>.</p>
<div class="fragment"><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;{</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p1);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p4);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p7);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p3);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p8);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p7);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p6);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p4);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p5);</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p7);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p2);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p4);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p2);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">return</span> p4;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;}</div><div class="ttc" id="non__linear__filter__helpers_8h_xhtml_ac226bc1ed04fd7d4865263484ed22a47"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a></div><div class="ttdeci">#define SORT(a, b)</div><div class="ttdoc">Sorts element-wise two vectors. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00030">non_linear_filter_helpers.h:30</a></div></div>
</div><!-- fragment -->
</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.xhtml">src</a></li><li class="navelem"><a class="el" href="dir_aebb8dcc11953d78e620bbef0b9e2183.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_8c278f79c760e5c5fbd911f9870614c1.xhtml">CL</a></li><li class="navelem"><a class="el" href="dir_25885286e9dad4fa105b7b25a8031bbf.xhtml">cl_kernels</a></li><li class="navelem"><a class="el" href="non__linear__filter__helpers_8h.xhtml">non_linear_filter_helpers.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
